unit GUI;

interface

uses eXgine, SysUtils, Math, MyInterface, EngineUtils, Consts, SpriteEngine, OpenGL;

const BtnStart    = 0;
      BtnSetting  = 1;
      BtnRecord   = 2;
      BtnExit     = 3;
      BtnWidth    = 200;
      BtnHeight   = 50;
      SnowCount1    = 30;
      SnowCount2    = 20;
      SnowMinSpeed  = 2;
      SnowMaxSpeed  = 7;
      AngleMaxSpeed = 10;
      AngleMinSpeed = 3;
      ScoreX        = 32;
      ScoreY        = 64;
      ScoreW        = 64;
      ScoreH        = 32;
      HealthX       = 32;
      HealthY       = 32;
      HealthWH      = 32;
      ReloadX       = 32;
      ReloadY       = 96;
      ReloadW       = 10;
      SetBoxMusic   = 1;
      SetBoxSound   = 2;
      SetBoxScreen  = 3;
      SetBtnSave    = 1;
      SetBtnDefault = 2;
      SetBtnExit    = 3;
      RecordMax     = 10;

type TSnow = record
       Visible: boolean;
       X,Y    : real;
       Speed  : real;
       Angle  : real;
       AngleSpeed: real;
     end;

type TRecord = record
       Name : string[32];
       Score: integer;
     end;

procedure FonInit;
procedure FonDraw;
procedure FonProcess;
procedure SnowDraw;
procedure SnowProcess;
procedure GUIInit;
procedure ScoreDraw;
procedure HealthDraw;
procedure ReloadDraw;
procedure SettingInit;
procedure StartSetting;
procedure SettingDraw;
procedure SettingProcess;
procedure SettingBtnDefault;
procedure SettingBtnSave;
procedure SettingBtnExit;
procedure RecordLoad;
procedure RecordSave;
procedure RecordOpen;
procedure RecordInit(score: integer);
procedure RecordDraw;
procedure RecordProcess;
procedure StopProcess;
procedure HelpDraw;
procedure HelpProcess;
procedure NumberDraw(x,y,w,h,num,alfa: integer);

var MyInt       : TMyInterface;
    FonSnow1    : array[0..SnowCount1] of TSnow;
    FonSnow2    : array[0..SnowCount2] of TSnow;
    texSnow1    : Cardinal;
    texSnow2    : Cardinal;
    texLogo     : cardinal;
    texScore    : cardinal;
    texHealth   : cardinal;
    texSnowTime : cardinal;
    SetButtons  : array[1..3] of TGlButton;
    SetCheckBox : array[1..3] of TGlCheckBox;
    SetBtnName  : array[1..3] of String = ('',' ','');
    SetCBoxName : array[1..3] of String = ('','',' ');
    Records     : array[1..RecordMax] of TRecord;
    RecordStatus: boolean;
    RecordEdit  : TGLEdit;
    RecordNum   : integer;
    texNumber   : cardinal;

implementation

uses Main, Player, Level;

procedure SnowInit1(num: integer);
begin
  FonSnow1[num].Visible:= true;
  FonSnow1[num].X:= Random(ScreenW);
  FonSnow1[num].Y:= Random(200)-200;
  FonSnow1[num].Speed:= (Random(SnowMaxSpeed-SnowMinSpeed)+SnowMinSpeed)*0.1;
  FonSnow1[num].Angle:= Random(360);
  if Random(2) = 0 then
    FonSnow1[num].AngleSpeed:= (Random(AngleMaxSpeed-AngleMinSpeed)+AngleMinSpeed)*0.1
  else
    FonSnow1[num].AngleSpeed:= -(Random(AngleMaxSpeed-AngleMinSpeed)+AngleMinSpeed)*0.1;
end;

procedure SnowInit2(num: integer);
begin
  FonSnow2[num].Visible:= true;
  FonSnow2[num].X:= Random(ScreenW);
  FonSnow2[num].Y:= Random(200)-200;
  FonSnow2[num].Speed:= (Random(SnowMaxSpeed-SnowMinSpeed)+SnowMinSpeed)*0.1;
  FonSnow2[num].Angle:= Random(360);
  FonSnow2[num].AngleSpeed:= (Random(AngleMaxSpeed-AngleMinSpeed)+AngleMinSpeed)*0.1;
end;

procedure FonInit;
var sCount: integer;
begin
  texSnow1:= tex.Load('data/snow1.tga');
  texSnow2:= tex.Load('data/snow2.tga');
  for sCount:= 0 to SnowCount1 do
  begin
    SnowInit1(sCount);
  end;
  for sCount:= 0 to SnowCount2 do
  begin
    SnowInit2(sCount);
  end;
end;

procedure FonDraw;
begin
  glBegin(GL_QUADS);
    glColor3f(0.1,0.4,0.9);
    glVertex2f(0, 0);
    glVertex2f(ScreenW, 0);
    glColor3f(0.9,0.9,0.9);
    glVertex2f(ScreenW, ScreenH);
    glVertex2f(0, ScreenH);
  glEnd;
  if (Status = StatusMenu) or (Status = StatusSetting) then
  begin
    DrawSprite2D_simple(texFon,0,0,wnd.Width,wnd.Height);
  end;
  if Status = StatusMenu then
    DrawText2D(0,8,32,'F1 -   ',$000000);
end;

procedure FonProcess;
begin
  ;
end;

procedure SnowDraw;
var sCount: integer;
begin
  for sCount:= 0 to SnowCount1 do
  begin
    if FonSnow1[sCount].Visible = true then
    begin
      if texSnow1 = 0 then
      begin
        glPointSize(5);
        glColor3f(1,1,1);
        glEnable (GL_POINT_SMOOTH);
        glBegin(GL_POINTS);
          glVertex2f(FonSnow1[sCount].X,FonSnow1[sCount].Y);
        glEnd;
      end
      else
        DrawSprite2D(texSnow1,Round(FonSnow1[sCount].X),Round(FonSnow1[sCount].Y),16,16,Round(FonSnow1[sCount].Angle),200,$FFFFFF,true);
    end;
    if FonSnow2[sCount].Visible = true then
    begin
      if texSnow2 = 0 then
      begin
        glPointSize(5);
        glColor3f(1,1,0.8);
        glEnable (GL_POINT_SMOOTH);
        glBegin(GL_POINTS);
          glVertex2f(FonSnow2[sCount].X,FonSnow1[sCount].Y);
        glEnd;
      end
      else
        DrawSprite2D(texSnow2,Round(FonSnow2[sCount].X),Round(FonSnow2[sCount].Y),16,16,Round(FonSnow2[sCount].Angle),200,$FFFFFF,true);
    end;
  end;
end;

procedure SnowProcess;
var sCount: integer;
begin
  for sCount:= 0 to SnowCount1 do
  begin
    if FonSnow1[sCount].Angle > 360 then
      FonSnow1[sCount].Angle:= 0
    else
      FonSnow1[sCount].Angle:= FonSnow1[sCount].Angle+FonSnow1[sCount].AngleSpeed;
    FonSnow1[sCount].Y:= FonSnow1[sCount].Y+FonSnow1[sCount].Speed;
    if FonSnow1[sCount].Y > 420 then
    begin
      SnowInit1(sCount);
    end;
  end;
  for sCount:= 0 to SnowCount2 do
  begin
    if FonSnow2[sCount].Angle > 360 then
      FonSnow2[sCount].Angle:= 0
    else
      FonSnow2[sCount].Angle:= FonSnow2[sCount].Angle+FonSnow2[sCount].AngleSpeed;
    FonSnow2[sCount].Y:= FonSnow2[sCount].Y+FonSnow2[sCount].Speed;
    if FonSnow2[sCount].Y > 420 then
    begin
      SnowInit2(sCount);
    end;
  end;
end;

procedure GUIInit;
begin
  TexBtn:= tex.Load('data\Btn.tga');
  TexCheckYes:= tex.Load('data\CheckYes.tga');
  TexCheckNo:= tex.Load('data\CheckNo.tga');
  TexEdt:= tex.Load('data\Edit.tga');
  texLogo:= tex.Load('data\logo.tga');
  texScore:= tex.Load('data\score.tga');
  texHealth:= tex.Load('data\health.tga');
  MyInt:= TMyInterface.Create;
  MyInt.CreateGLButton(50,25+wnd.Height div 2-((5*BtnHeight+4*25) div 2),BtnWidth,BtnHeight,250,$000000,' ',@NewGame,TexBtn);
  MyInt.CreateGLButton(50,(25+BtnHeight)+wnd.Height div 2-((4*BtnHeight+4*25) div 2),BtnWidth,BtnHeight,250,$000000,'',@StartSetting,TexBtn);
  MyInt.CreateGLButton(50,(25+BtnHeight)*2+wnd.Height div 2-((4*BtnHeight+4*25) div 2),BtnWidth,BtnHeight,250,$000000,'',@RecordOpen,TexBtn);
  MyInt.CreateGLButton(50,(25+BtnHeight)*3+wnd.Height div 2-((4*BtnHeight+4*25) div 2),BtnWidth,BtnHeight,250,$000000,'',@MainExit,TexBtn);

  RecordEdit:= TGLEdit.Create(0,0,100,32,1,32,$0000FF,'','',false,TexEdt);
  RecordEdit.Proc:= @StopProcess;
  RecordEdit.Enable:= false;
end;

procedure ScoreDraw;
begin
  DrawSprite2D_simple(texScore,ScoreX,ScoreY,ScoreW,ScoreH);
  NumberDraw(ScoreX+ScoreW,ScoreY,12,ScoreH,Players.Score,255);
  //DrawText2D(0,ScoreX+ScoreW,ScoreY+GetTextHeight div 2,inttostr(Players.Score),$0000FF);
end;

procedure HealthDraw;
var numHealth: integer;
begin
  for numHealth:= 0 to Players.Health-1 do
    DrawSprite2D_simple(texHealth,HealthX+(HealthWH*numHealth),HealthY,HealthWH,HealthWH);
end;

procedure ReloadDraw;
begin
  DrawSprite2D_simple(texSnowTime,ReloadX,ReloadY,64,16);
  DrawLine2D(ReloadX+70,ReloadY+GetTextHeight div 2,ReloadX+70+Players.ReloadAmmo,
             ReloadY+GetTextHeight div 2,$0000FF,200,ReloadW);
end;

procedure SettingInit;
var num: integer;
begin
  for num:= 1 to 3 do
    SetButtons[num]:= TGlButton.Create(100+210*(num-1),500,200,50,255,$000000,SetBtnName[num],TexBtn);
  SetButtons[SetBtnDefault].bProc:= @SettingBtnDefault;
  SetButtons[SetBtnSave].bProc:= @SettingBtnSave;
  SetButtons[SetBtnExit].bProc:= @SettingBtnExit;
  for num:= 1 to 3 do
    SetCheckBox[num]:= TGlCheckBox.Create(100,50+100*num,48,48,0,$FF0000,SetCBoxName[num],TexCheckYes,TexCheckNo);
end;

procedure StartSetting;
begin
  Status:= StatusSetting;
end;

procedure SettingDraw;
var num: integer;
begin
  for num:= 1 to 3 do
    SetButtons[num].Draw;
  for num:= 1 to 3 do
    SetCheckBox[num].Draw;
end;

procedure SettingProcess;
var num: integer;
begin
  for num:= 1 to 3 do
    SetButtons[num].Process;
  for num:= 1 to 3 do
    SetCheckBox[num].Process;
end;

procedure SettingBtnDefault;
begin
  SoundOn:= defaultSound;
  MusicOn:= defaultMusic;
  FullScreenOn:= defaultFullScreen;
  SetCheckBox[SetBoxMusic].Status:= defaultMusic;
  SetCheckBox[SetBoxSound].Status:= defaultSound;
  SetCheckBox[SetBoxScreen].Status:= defaultFullScreen;
  SettingSave(MusicOn,SoundOn,FullScreenOn);
end;

procedure SettingBtnSave;
begin
  SoundOn:= SetCheckBox[SetBoxSound].Status;
  MusicOn:= SetCheckBox[SetBoxMusic].Status;
  if FullScreenOn <> SetCheckBox[SetBoxScreen].Status then
  begin
    if SetCheckBox[SetBoxScreen].Status = 0 then
      wnd.Mode(true, 0, 0, ScreenW, ScreenH, 32, 75)
    else
      wnd.Mode(false, ScreenStartX, ScreenStartY, ScreenW, ScreenH, 32, 75);
  end;
  FullScreenOn:= SetCheckBox[SetBoxScreen].Status;
  if MusicOn = 1 then
    snd.StopFile;
  SettingSave(MusicOn,SoundOn,FullScreenOn);
end;

procedure SettingBtnExit;
begin
  SettingLoad;
  Status:= StatusMenu;
end;

procedure RecordLoad;
var num: integer;
    F: File;
begin
  for num:= 1 to RecordMax do
  begin
    Records[num].Name:= '<>';
    Records[num].Score:= 0;
  end;
  if not FileExists('record.rds') then
    exit;
  Assign(F, 'record.rds');
  Reset(F,1);
  for num:= 1 to RecordMax do
    BlockRead(F, Records, SizeOf(Records));
  Close(F);
end;

procedure RecordSave;
var F: File;
    num: integer;
begin
  Assign(F, 'record.rds');
  Rewrite(F,1);
  for num:= 1 to RecordMax do
    BlockWrite(F, Records, SizeOf(Records));
  Close(F);
end;

procedure RecordOpen;
begin
  RecordInit(-1);
end;

procedure RecordInit(score: integer);
var num: integer;
begin
  if score > 0 then
  begin
    RecordEdit.Enable:= true;
    RecordEdit.Status:= true;
    inp.StartGLKeyboardTextInput;
    RecordEdit.Rect.x:= 250;
    RecordEdit.Rect.w:= 200;
    RecordEdit.Rect.h:= 32;

    for num:= RecordMax downto 1 do
    begin
      if Score < Records[num].Score then
      begin
        if num = 10 then
        begin
          RecordNum:= num;
          Records[num].Score:= score;
        end
        else
        begin
          RecordNum:= num+1;
          Records[num+1].Score:= score;
        end;
        break;
      end
      else
      begin
        if num = 1 then
        begin
          RecordNum:= 1;
          Records[num].Score:= score;
        end
        else
          Records[num].Score:= Records[num-1].score;
      end;
    end;
  end;
  RecordEdit.Rect.y:= (wnd.Height div 2) - (RecordMax*32 div 2)+32*(RecordNum-1);
  Status:= StatusRecord;
end;

procedure RecordDraw;
var num: integer;
begin
  for num:= 1 to RecordMax do
  begin
    DrawSprite2D_simple(TexEdt,250,(wnd.Height div 2) - (RecordMax*32 div 2)+32*(num-1),300,32);
    DrawText2D(0,275,8+(wnd.Height div 2) - (RecordMax*32 div 2)+32*(num-1),Records[num].Name,$FF0000);
    DrawText2D(0,470,8+(wnd.Height div 2) - (RecordMax*32 div 2)+32*(num-1),IntToStr(Records[num].Score),$0000FF);
  end;
  RecordEdit.Draw;
end;

procedure RecordProcess;
begin
  RecordEdit.Process;
end;

procedure StopProcess;
begin
  RecordEdit.Enable:= false;
  Records[RecordNum].Name:= RecordEdit.TextEdit;
  RecordSave;
end;

procedure HelpDraw;
begin
  DrawText2D(0,(wnd.Width div 2)-(GetTextWidth(0,'') div 2),45,'',$0000FF);
  DrawText2D(0,16,64,'',$FF0000);
  DrawSprite2D(texBonus,16,80,32,32,0,255,$FFFFFF,false,32,32,1,4);
  DrawText2D(0,64,88,' - 150 ',$000000);
  DrawSprite2D(texBonus,16,116,32,32,0,255,$FFFFFF,false,32,32,2,4);
  DrawText2D(0,64,116,' -  ',$000000);
  DrawText2D(0,64,132,'+ 500 ',$000000);
  DrawSprite2D(texBonus,16,152,32,32,0,255,$FFFFFF,false,32,32,3,4);
  DrawText2D(0,64,152,' - ',$000000);
  DrawText2D(0,64,168,'   + 100 ',$000000);
  DrawSprite2D(texBonus,16,188,32,32,0,255,$FFFFFF,false,32,32,4,4);
  DrawText2D(0,64,188,' -    5 ',$000000);
  DrawText2D(0,64,204,'+ 80 ',$000000);
  DrawText2D(0,16,232,' ',$FF0000);
  DrawSprite2D(texPlace,16,248,32,32,0,255,$FFFFFF,false,32,32,1,4);
  DrawText2D(0,64,256,' -  ',$000000);
  DrawSprite2D(texPlace,16,284,32,32,0,255,$FFFFFF,false,32,32,2,4);
  DrawSprite2D(texPlace,52,284,32,32,0,255,$FFFFFF,false,32,32,2,4);
  DrawSprite2D_simple(texSnow1,60,272,16,16,255,$0000FF,false);
  DrawText2D(0,100,284,'  -',$000000);
  DrawText2D(0,100,300,'  /',$000000);
  DrawSprite2D(texPlace,16,320,32,32,0,255,$FFFFFF,false,32,32,3,4);
  DrawText2D(0,64,328,'   -  ',$000000);
  DrawSprite2D(texPlace,16,356,32,32,0,255,$FFFFFF,false,32,32,4,4);
  DrawText2D(0,64,364,'   -  ',$000000);
  DrawText2D(0,16,400,' ',$FF0000);
  DrawSprite2D(texTrap,16,416,32,32,0,255,$FFFFFF,false,32,32,3,4);
  DrawText2D(0,64,416,'  -  ',$000000);
  DrawText2D(0,64,432,'(   )',$000000);
  DrawSprite2D(texTrap,16,452,32,32,0,255,$FFFFFF,false,32,32,4,4);
  DrawText2D(0,64,452,'  - ,',$000000);
  DrawText2D(0,64,468,'   ',$000000);
  DrawText2D(0,450,64,'',$FF0000);
  DrawText2D(0,450,78,'  -  ',$000000);
  DrawText2D(0,450,100,'  -  ',$000000);
  DrawText2D(0,450,122,' -  ',$000000);
  DrawText2D(0,450,144,'  -  ',$000000);
  DrawText2D(0,450,166,' - ',$000000);
  DrawText2D(0,450,188,' - P()',$000000);
  DrawText2D(0,450,210,' - ESC',$000000);
  DrawText2D(0,450,236,'',$FF0000);
  DrawSprite2D_simple(texHealth,450,260,32,32);
  DrawText2D(0,492,268,'  -  3',$000000);
  DrawSprite2D_simple(texSnowTime,450,296,64,16);
  DrawLine2D(450,320,482,320,$0000FF,200,ReloadW);
  DrawText2D(0,524,296,' - ',$000000);
  DrawText2D(0,524,312,'    ',$000000);
  DrawText2D(0,450,400,' xProger'''+' ',$FF0000);
  DrawText2D(0,450,416,'  eXgine',$FF0000);
  DrawText2D(0,450,432,'    ',$FF0000);
end;

procedure HelpProcess;
begin
  if InKey(Key_Escape) then
    Status:= StatusMenu;
end;

procedure NumberDraw(x,y,w,h,num,alfa: integer);
var i: integer;
    tmpStr: string;
begin
  tmpStr:= inttostr(num);
  for i:= 1 to Length(tmpStr) do
  begin
    if StrToInt(tmpStr[i]) = 0 then
      DrawSprite2D(texNumber,x+i*w,y,w,h,0,alfa,$FFFFFF,true,w,h,10,10)
    else
      DrawSprite2D(texNumber,x+i*w,y,w,h,0,alfa,$FFFFFF,true,w,h,strtoint(tmpStr[i]),10);
  end;
end;

end.
