unit MyInterface;
//   

interface

uses eXgine, SysUtils, Math, EngineUtils, Consts, SpriteEngine, OpenGL;

const MainCursorW = 32;
      MainCursorH = 32;
      ButtonColorTrans: integer = TRANSCOLOR_AQUA;
      CheckColorTrans : integer = TRANSCOLOR_AQUA;
      EditColorTrans  : integer = TRANSCOLOR_AQUA;

var
  FullScreenFlag  : boolean = false;
  CursorX, CursorY: integer;
  MouseDown       : byte = MB_NONE;
  MouseWheel      : integer = 0;
  FontInterface   : cardinal;
  MainCursorTex   : Cardinal;
  MainCursorShow  : boolean = true;

//
type TGlButton = class
       texBtn   : Cardinal;
       bRect    : TRect;
       bCaption : String;
       bStatus  : boolean;
       bProc    : procedure;
       bAlfa    : integer;
       bEnable  : boolean;
       Visible  : boolean;
       TextColor: integer;
       constructor Create(x,y,w,h,a,txtColor: integer; text: string; texB: cardinal = 0);
       procedure   Process;
       procedure   Draw;
       destructor  Destroy; override;
     end;
//
type TGlCheckBox = class
       texYes   : Cardinal;
       texNo    : Cardinal;
       Rect     : TRect;
       Status   : integer;//0 -  1 - 
       Caption  : string;
       Proc     : procedure;
       Enable   : boolean;
       TextColor: integer;
       constructor Create(x,y,w,h,s,txtColor: integer; text: string; texY: cardinal = 0; texN: cardinal = 0);
       procedure   Process;
       procedure   Draw;
       destructor  Destroy; override;
     end;

//  
type TGLEdit = class
       texEdit     : Cardinal;
       Rect        : TRect;
       Enable      : boolean;
       Caption     : string;
       CaptionPlace: integer; //   0 -  1  2 - 
       Status      : boolean; // 0 -  1 -  
       Proc        : procedure;
       SizeCur     : integer;
       PosCur      : integer;
       TextEdit    : string;
       TimerCur    : integer;
       MaxLen      : integer;
       textColor   : integer;
       constructor Create(x,y,w,h,CP,ML,txtColor: integer; Cap, Text: string; s: boolean; texE: cardinal = 0);
       procedure   Process;
       procedure   Draw;
       destructor  Destroy; override;
     end;

// --   

// 
type TMyInterface = class
        GLEditAr    : array of TGLEdit;
        GLCheckBoxAr: array of TGlCheckBox;
        GLButtonAr  : array of TGlButton;
        procedure   CreateGLButton(x,y,w,h,a,txtColor: integer; text: string; Proc: Pointer; texB: cardinal = 0);
        procedure   CreateGLCheck(x, y, w, h, s,txtColor: integer; text: string; Proc: Pointer; texY: cardinal = 0; texN: cardinal = 0);
        procedure   CreateGLEdit(x,y,w,h,CP,ML,txtColor: integer; Cap, Text: string; s: boolean; Proc: Pointer; texE: cardinal = 0);
        constructor Create;
        procedure   Process;
        procedure   Draw;
        destructor  Destroy; override;
      end;

var TexBtn       : Cardinal;
    TexCheckYes  : Cardinal;
    TexCheckNo   : cardinal;
    TexEdt       : cardinal;
    //Fon              : cardinal;

implementation

{ TGlButton }

constructor TGlButton.Create(x, y, w, h, a,txtColor: integer; text: string; texB: cardinal = 0);
begin
  bRect:=ReturnRect(x,y,w,h);
  bCaption:= text;
  bStatus:= False;
  bAlfa:= a;
  bEnable:= true;
  Visible:= true;
  bProc:= nil;
  TextColor:= txtColor;
  texBtn:= texB;
end;

destructor TGlButton.Destroy;
begin
  inherited;
end;

procedure TGlButton.Draw;
var w,h: integer;
begin
  w:= ogl.TextLen(FontInterface,pchar(bCaption));
  h:= GetTextHeight;
  if bStatus = false then
  begin
    if texBtn = 0 then
    begin
      glBegin(GL_QUADS);
        glColor3f(0.5,0.5,0.5);
        glVertex2f(bRect.x, bRect.y);
        glVertex2f(bRect.x+bRect.w, bRect.y);
        glColor3f(0.8,0.8,0.8);
        glVertex2f(bRect.x+bRect.w, bRect.y+bRect.h);
        glVertex2f(bRect.x, bRect.y+bRect.h);
      glEnd;
    end
    else
      DrawSprite2D_simple(texBtn,bRect.x,bRect.y,bRect.w,bRect.h);
    if bCaption <> '' then
      DrawText2D(FontInterface, bRect.x + bRect.w div 2 - w div 2,
                 bRect.y + bRect.h div 2 - h div 2,bCaption,textColor,bAlfa);
  end
  else
  begin
    if texBtn = 0 then
    begin
      glBegin(GL_QUADS);
        glColor3f(0.4,0.4,0.4);
        glVertex2f(bRect.x, bRect.y);
        glVertex2f(bRect.x+bRect.w, bRect.y);
        glColor3f(0.7,0.7,0.7);
        glVertex2f(bRect.x+bRect.w, bRect.y+bRect.h);
        glVertex2f(bRect.x, bRect.y+bRect.h);
      glEnd;
      DrawLine2D(bRect.x-1, bRect.y, bRect.x+bRect.w,bRect.y,$000000,255,1);
      DrawLine2D(bRect.x+bRect.w, bRect.y, bRect.x+bRect.w,bRect.y+bRect.h,$000000,255,1);
      DrawLine2D(bRect.x+bRect.w, bRect.y+bRect.h, bRect.x,bRect.y+bRect.h,$000000,255,1);
      DrawLine2D(bRect.x, bRect.y+bRect.h, bRect.x,bRect.y,$000000,255,1);
    end
    else
      DrawSprite2D_simple(texBtn,bRect.x,bRect.y,bRect.w,bRect.h,155);
    if bCaption <> '' then
      DrawText2D(FontInterface,bRect.x + bRect.w div 2 - w div 2,
                 bRect.y + bRect.h div 2 - h div 2,bCaption,textColor,bAlfa);
  end;
end;

procedure TGlButton.Process;
begin
  if PointInRect(CursorX,CursorY,bRect) = true then
  begin
    if (GetMouseButtonPressed = MB_LEFT) and (MouseDown = MB_NONE) then
    begin
      if @bProc <> nil then
      begin
        bProc;
      end;
    end;
    bStatus:= true;
  end
  else
    bStatus:= false;
end;


{ TMyInterface }

constructor TMyInterface.Create;
begin
  FontInterface:= 0;
end;

procedure TMyInterface.CreateGLButton(x, y, w, h, a,txtColor: integer; text: string;
          Proc: Pointer; texB: cardinal = 0);
var LengthAr: integer;
begin
  LengthAr:=Length(GLButtonAr)+1;
  SetLength(GLButtonAr,LengthAr);
  GLButtonAr[LengthAr-1]:= TGlButton.Create(x,y,w,h,a,txtColor,text,texB);
  GLButtonAr[LengthAr-1].bProc:= Proc;
end;

procedure TMyInterface.CreateGLCheck(x, y, w, h, s,txtColor: integer; text: string;
          Proc: Pointer; texY: cardinal = 0; texN: cardinal = 0);
var LengthAr: integer;
begin
  LengthAr:=Length(GLCheckBoxAr)+1;
  SetLength(GLCheckBoxAr,LengthAr);
  GLCheckBoxAr[LengthAr-1]:= TGlCheckBox.Create(x,y,w,h,s,txtColor,text,texY,texN);
  GLCheckBoxAr[LengthAr-1].Proc:= Proc;
end;

procedure TMyInterface.CreateGLEdit(x, y, w, h, CP, ML,txtColor: integer; Cap,
  Text: string; s: boolean; Proc: Pointer; texE: cardinal = 0);
var LengthAr: integer;
begin
  LengthAr:=Length(GLEditAr)+1;
  SetLength(GLEditAr,LengthAr);
  GLEditAr[LengthAr-1]:= TGLEdit.Create(x,y,w,h,CP,ML,txtColor,Cap,text,s,texE);
  GLEditAr[LengthAr-1].Proc:= Proc;
end;

destructor TMyInterface.Destroy;
var i: integer;
    lengthArr: integer;
begin
  lengthArr:= length(GLButtonAr)-1;
  for i:= 0 to lengthArr do
    GLButtonAr[i].Destroy;
  lengthArr:= length(GLCheckBoxAr)-1;
  for i:= 0 to lengthArr do
    GLCheckBoxAr[i].Destroy;
  lengthArr:= length(GLEditAr)-1;
  for i:= 0 to lengthArr do
    GLEditAr[i].Destroy;
  ogl.Font.Free(FontInterface);
  tex.Free(MainCursorTex);
  tex.Free(TexBtn);
  tex.Free(TexCheckYes);
  tex.Free(TexCheckNo);
  tex.Free(TexEdt);
  inherited;
end;

procedure TMyInterface.Draw;
var LengthAr: integer;
    i: integer;
begin
  LengthAr:=Length(GLButtonAr)-1;
  for i:= 0 to LengthAr do
  begin
    if GLButtonAr[i].Visible = true then
    begin
      GLButtonAr[i].Draw;
    end;
  end;
  LengthAr:=Length(GLCheckBoxAr)-1;
  for i:= 0 to LengthAr do
  begin
    if GLCheckBoxAr[i].Enable = true then
    begin
      GLCheckBoxAr[i].Draw;
    end;
  end;
  LengthAr:=Length(GLEditAr)-1;
  for i:= 0 to LengthAr do
  begin
    if GLEditAr[i].Enable = true then
    begin
      GLEditAr[i].Draw;
    end;
  end;
end;

procedure TMyInterface.Process;
var LengthAr: integer;
    i: integer;
begin
  LengthAr:=Length(GLButtonAr)-1;
  for i:= 0 to LengthAr do
  begin
    if (GLButtonAr[i].bEnable = true) and (GLButtonAr[i].Visible = true) then
    begin
      GLButtonAr[i].Process;
    end;
  end;
  LengthAr:=Length(GLCheckBoxAr)-1;
  for i:= 0 to LengthAr do
  begin
    if GLCheckBoxAr[i].Enable = true then
    begin
      GLCheckBoxAr[i].Process;
    end;
  end;
  LengthAr:=Length(GLEditAr)-1;
  for i:= 0 to LengthAr do
  begin
    if GLEditAr[i].Enable = true then
    begin
      GLEditAr[i].Process;
    end;
  end;
end;

{ TGlCheckBox }

constructor TGlCheckBox.Create(x, y, w, h, s,txtColor: integer; text: string; texY: cardinal = 0; texN: cardinal = 0);
begin
  Rect:= ReturnRect(x,y,w,h);
  Status:= s;
  Caption:= text;
  Proc:= nil;
  Enable:= true;
  TextColor:= txtColor;
  texYes:= texY;
  texNo:= texN;
end;

destructor TGlCheckBox.Destroy;
begin
  inherited;
end;

procedure TGlCheckBox.Draw;
var h: integer;
begin
  if Status = 0 then
  begin
    if (texYes = 0) or (texNo = 0) then
    begin
      glBegin(GL_QUADS);
        glColor3f(0.5,0.5,0.5);
        glVertex2f(Rect.x, Rect.y);
        glVertex2f(Rect.x+Rect.w, Rect.y);
        glColor3f(0.8,0.8,0.8);
        glVertex2f(Rect.x+Rect.w, Rect.y+Rect.h);
        glVertex2f(Rect.x, Rect.y+Rect.h);
      glEnd;
      DrawLine2D(Rect.x, Rect.y, Rect.x+Rect.w,Rect.y,$000000,255,2);
      DrawLine2D(Rect.x+Rect.w, Rect.y, Rect.x+Rect.w,Rect.y+Rect.h,$000000,255,2);
      DrawLine2D(Rect.x+Rect.w, Rect.y+Rect.h, Rect.x,Rect.y+Rect.h,$000000,255,2);
      DrawLine2D(Rect.x, Rect.y+Rect.h, Rect.x,Rect.y,$000000,255,2);
      DrawLine2D(Rect.x+4, Rect.y+4, Rect.x+Rect.w-4,Rect.y+Rect.h-4,$000000,255,2);
      DrawLine2D(Rect.x+Rect.w-4, Rect.y+4, Rect.x+4,Rect.y+Rect.h-4,$000000,255,2);
    end
    else
      DrawSprite2D_simple(texYes,Rect.x,Rect.y,Rect.w,Rect.h);
  end
  else
  begin
    if (texYes = 0) or (texNo = 0) then
    begin
      glBegin(GL_QUADS);
        glColor3f(0.5,0.5,0.5);
        glVertex2f(Rect.x, Rect.y);
        glVertex2f(Rect.x+Rect.w, Rect.y);
        glColor3f(0.8,0.8,0.8);
        glVertex2f(Rect.x+Rect.w, Rect.y+Rect.h);
        glVertex2f(Rect.x, Rect.y+Rect.h);
      glEnd;
      DrawLine2D(Rect.x, Rect.y, Rect.x+Rect.w,Rect.y,$000000,255,2);
      DrawLine2D(Rect.x+Rect.w, Rect.y, Rect.x+Rect.w,Rect.y+Rect.h,$000000,255,2);
      DrawLine2D(Rect.x+Rect.w, Rect.y+Rect.h, Rect.x,Rect.y+Rect.h,$000000,255,2);
      DrawLine2D(Rect.x, Rect.y+Rect.h, Rect.x,Rect.y,$000000,255,2);
    end
    else
      DrawSprite2D_simple(texNo,Rect.x,Rect.y,Rect.w,Rect.h);
  end;
  h:= GetTextHeight;
  DrawText2D(FontInterface,Rect.x+Rect.w+10,
             Rect.y + Rect.h div 2 - h div 2,Caption,textColor,200);
end;

procedure TGlCheckBox.Process;
begin
 if (PointInRect(CursorX,CursorY,Rect) = true) and
    (GetMouseButtonPressed = MB_LEFT) and (MouseDown = MB_NONE) then
 begin
   if Status = 0 then
     Status:= 1
   else
     Status:= 0;
   if @Proc <> nil then
   begin
     Proc;
   end;
 end;
end;

{ TGLEdit }

constructor TGLEdit.Create(x,y,w,h,CP,ML,txtColor: integer; Cap, Text: string; s: boolean; texE: cardinal = 0);
begin
  Rect:= ReturnRect(x,y,w,h);
  Enable:= true;
  Caption:= Cap;
  CaptionPlace:= CP;
  Status:= s;
  Proc:= nil;
  SizeCur:= GetTextHeight;
  PosCur:= 0;
  TextEdit:= Text;
  TimerCur:=0;
  MaxLen:= ML;
  textColor:= txtColor;
  texEdit:= texE;
end;

destructor TGLEdit.Destroy;
begin
  inherited;
end;

procedure TGLEdit.Draw;
var xC,yC: integer;
    tmpText: string;
    i, firstNmb: integer;
    flag: boolean;
begin
  if Enable = false then
    exit;
  if texEdit = 0 then
  begin
    glBegin(GL_QUADS);
      glColor3f(0.5,0.5,0.5);
      glVertex2f(Rect.x, Rect.y);
      glVertex2f(Rect.x+Rect.w, Rect.y);
      glColor3f(0.8,0.8,0.8);
      glVertex2f(Rect.x+Rect.w, Rect.y+Rect.h);
      glVertex2f(Rect.x, Rect.y+Rect.h);
    glEnd;
    DrawLine2D(Rect.x, Rect.y, Rect.x+Rect.w,Rect.y,$000000,255,2);
    DrawLine2D(Rect.x+Rect.w, Rect.y, Rect.x+Rect.w,Rect.y+Rect.h,$000000,255,2);
    DrawLine2D(Rect.x+Rect.w, Rect.y+Rect.h, Rect.x,Rect.y+Rect.h,$000000,255,2);
    DrawLine2D(Rect.x, Rect.y+Rect.h, Rect.x,Rect.y,$000000,255,2);
  end
  else
    DrawSprite2D_simple(texEdit,Rect.x,Rect.y,Rect.w,Rect.h);
  if ogl.TextLen(FontInterface,pChar(TextEdit))>Rect.w-3 then
  begin
    flag:= true;
    firstNmb:= 2;
    while flag do
    begin
      tmpText:= '';
      for i:= firstNmb to length(TextEdit) do
      begin
        tmpText:= tmpText+TextEdit[i];
      end;
      if ogl.TextLen(FontInterface,pChar(tmpText)) <= Rect.w-3 then
        flag:= false;
      inc(firstNmb,1);
    end;
    if (TimerCur < 15) and (Status = true) then
    begin
      xC:= Rect.x+3+ogl.TextLen(FontInterface,pChar(tmpText))+1;
      yC:= Rect.y+(Rect.h div 2)-(SizeCur div 2);
      DrawLine2D(xC,yC,xC,yC+SizeCur,textColor,255,2);
    end;
    DrawText2D(FontInterface,Rect.x+3,(Rect.y+(Rect.h div 2)-(SizeCur div 2)),
               tmpText,textColor,255);
  end
  else
  begin
    if (TimerCur < 15) and (Status = true) then
    begin
      xC:= Rect.x+3+ogl.TextLen(FontInterface,pChar(TextEdit))+1;
      yC:= Rect.y+(Rect.h div 2)-(SizeCur div 2);
      DrawLine2D(xC,yC,xC,yC+SizeCur,textColor,255,2);
    end;
    DrawText2D(FontInterface,Rect.x+3,(Rect.y+(Rect.h div 2)-(SizeCur div 2)),
               TextEdit,textColor,255);
  end;
  case CaptionPlace of
    0:begin
        DrawText2D(FontInterface,Rect.x-ogl.TextLen(FontInterface,pChar(Caption))-2,
        (Rect.y+(Rect.h div 2)-(SizeCur div 2)),Caption,textColor,255);
      end;
    1:begin
        DrawText2D(FontInterface,Rect.x,
        Rect.y-GetTextHeight-2,Caption,textColor,255);
      end;
    2:begin
        DrawText2D(FontInterface,Rect.x+Rect.w+2,
        (Rect.y+(Rect.h div 2)-(SizeCur div 2)),Caption,textColor,255);
      end;
  end;
end;

procedure TGLEdit.Process;
begin
  if Enable = false then
    exit;
  if PointInRect(CursorX,CursorY,Rect) = true then
  begin
    if (GetMouseButtonPressed = MB_LEFT) and (MouseDown = MB_NONE) then
    begin
      inp.StartGLKeyboardTextInput;
      Status:= true;
    end;
  end
  else
  begin
    if (GetMouseButtonPressed = MB_LEFT) and (MouseDown = MB_NONE) and (Status = true) then
    begin
      inp.EndGLKeyboardTextInput;
      if @Proc <> nil then
      begin
        Proc;
      end;
      Status:= false;
    end;
  end;
  if Status then
  begin
    if InKey(Key_Escape) = true then
    begin
      inp.EndGLKeyboardTextInput;
      if @Proc <> nil then
      begin
        Proc;
      end;
      Status:= false;
    end;
    if TimerCur > 30 then
      TimerCur := 0
    else
      inc(TimerCur,1);
    TextEdit:= GLTextUtil(TextEdit,MaxLen); //--    
  end;
end;

end.
