unit redactor;

interface

uses Windows, eXgine, SysUtils, Math, MyInterface, EngineUtils, Consts, SpriteEngine, OpenGL, level, GUI, Enemy;

const ElementX        = 668;
      ElementY        = 100;
      ElementW        = 128;
      ElementH        = 32;
      CameraRedoSpeed = 5;
      MenuWidth       = 170;
      FonObjY         = 148;
      FonObjW         = 64;
      FonObjH         = 32;
      TrapY           = 196;
      TrapW           = 64;
      TrapH           = 32;
      TrapCount       = 2;
      BonusRedoY      = 244;
      BonusRedoW      = 128;
      BonusRedoH      = 32;
      BonusRedoCount  = 4;
      PlaceRedoY      = 292;
      PlaceRedoW      = 128;
      PlaceRedoH      = 32;
      PlaceRedoCount  = 4;
      EnemyRedoY      = 340;
      EnemyRedoW      = 96;
      EnemyRedoH      = 32;
      EnemyRedoCount  = 3;

procedure RedactorStart;
procedure RedactorProcess;
procedure RedactorDraw;
procedure ElementDraw;
procedure ElementCursorDraw;
procedure MiniMapDraw;
procedure SaveLevelRedo;
procedure LoadLevelRedo;
procedure AnimationProc;

var ActiveElement   : integer = 0;
    PixelElement,
    AnimationElement: TGlCheckBox;
    BtnSave,BtnLoad : TGlButton;
    EdtSpeed,
    EdtDeltaX,
    EdtDeltaY       : TGLEdit;
    Level0          : TLevel;
    AnimationOn     : boolean;

implementation

uses Main;

procedure RedactorStart;
begin
  Status:= StatusRedactor;
  ActiveElement:= 0;
  AnimationOn:= false;
  if PixelElement = nil then
    PixelElement:= TGlCheckBox.Create(ElementX-32,48,16,16,1,$BBBBBB,'  ');
  if AnimationElement = nil then
  begin
    AnimationElement:= TGlCheckBox.Create(ElementX-32,66,16,16,1,$BBBBBB,'/ ');
    AnimationElement.Proc:= @AnimationProc;
  end;
  if BtnSave = nil then
    BtnSave:= TGlButton.Create(635,420,75,25,255,$FFFFFF,'');
  BtnSave.bProc:= @SaveLevelRedo;
  if BtnLoad = nil then
    BtnLoad:= TGlButton.Create(720,420,75,25,255,$FFFFFF,'');
  if EdtSpeed = nil then
    EdtSpeed:= TGLEdit.Create(635,468,50,25,1,4,$FFFFFF,'','0',false);
  if EdtDeltaX = nil then
    EdtDeltaX:= TGLEdit.Create(635,512,50,25,1,4,$FFFFFF,'  X','0',false);
  if EdtDeltaY = nil then
    EdtDeltaY:= TGLEdit.Create(635,560,50,25,1,4,$FFFFFF,'  Y','0',false);
  BtnLoad.bProc:= @LoadLevelRedo;
  if Level0 = nil then
    Level0:= TLevel.Create;
  Level0.Init;
end;

procedure RedactorProcess;
begin
  Level0.Process(ActiveElement,AnimationOn,true);
  PixelElement.Process;
  AnimationElement.Process;
  BtnSave.Process;
  BtnLoad.Process;
  EdtSpeed.Process;
  EdtDeltaX.Process;
  EdtDeltaY.Process;
  if PointInRect(CursorX,CursorY,ReturnRect(ElementX-32,ElementY,ElementW+32,ElementH)) then
  begin
    if (GetMouseButtonPressed = MB_LEFT) and (MouseDown = MB_NONE) then
    begin
      ActiveElement:= (CursorX-(ElementX-32)) div 32;
    end;
  end;
  if PointInRect(CursorX,CursorY,ReturnRect(ElementX,FonObjY,FonObjW,FonObjH)) then
  begin
    if (GetMouseButtonPressed = MB_LEFT) and (MouseDown = MB_NONE) then
    begin
      ActiveElement:= ((CursorX-(ElementX-32)) div 32)+numTexGround;
    end;
  end;
  if PointInRect(CursorX,CursorY,ReturnRect(ElementX,TrapY,TrapW,TrapH)) then
  begin
    if (GetMouseButtonPressed = MB_LEFT) and (MouseDown = MB_NONE) then
    begin
      ActiveElement:= ((CursorX-(ElementX-32)) div 32)+numTexGround+numTexTrap;
    end;
  end;
  if PointInRect(CursorX,CursorY,ReturnRect(ElementX,BonusRedoY,BonusRedoW,BonusRedoH)) then
  begin
    if (GetMouseButtonPressed = MB_LEFT) and (MouseDown = MB_NONE) then
    begin
      ActiveElement:= ((CursorX-(ElementX-32)) div 32)+numTexGround+numTexTrap+numTexFonObj;
    end;
  end;
  if PointInRect(CursorX,CursorY,ReturnRect(ElementX,PlaceRedoY,PlaceRedoW,PlaceRedoH)) then
  begin
    if (GetMouseButtonPressed = MB_LEFT) and (MouseDown = MB_NONE) then
    begin
      ActiveElement:= ((CursorX-(ElementX-32)) div 32)+numTexGround+numTexTrap+numTexFonObj+BonusRedoCount;
    end;
  end;
  if PointInRect(CursorX,CursorY,ReturnRect(ElementX,EnemyRedoY,EnemyRedoW,EnemyRedoH)) then
  begin
    if (GetMouseButtonPressed = MB_LEFT) and (MouseDown = MB_NONE) then
    begin
      ActiveElement:= ((CursorX-(ElementX-32)) div 32)+numTexGround+
                      numTexTrap+numTexFonObj+BonusRedoCount+PlaceRedoCount;
    end;
  end;
  if (GetMouseButtonPressed = MB_LEFT) and (MouseDown = MB_NONE) and
     (CursorX < wnd.Width-MenuWidth) then
  begin
    if (ActiveElement > 0) and (ActiveElement <= numTexGround) then
    begin
      if PixelElement.Status = 0 then
        Level0.GroundAdd(((CameraMainX+CursorX) div groundW)*groundW,(CursorY div groundH)*groundH,groundW,groundH,ActiveElement,False,strtoint(EdtSpeed.TextEdit),strtoint(EdtDeltaX.TextEdit),strtoint(EdtDeltaY.TextEdit))
      else
        Level0.GroundAdd(CameraMainX+CursorX,CursorY,groundW,groundH,ActiveElement,False,strtoint(EdtSpeed.TextEdit),strtoint(EdtDeltaX.TextEdit),strtoint(EdtDeltaY.TextEdit));
    end;
    if (ActiveElement > numTexGround) and (ActiveElement <= numTexGround+numTexFonObj) then
    begin
      if PixelElement.Status = 0 then
        Level0.GroundAdd(((CameraMainX+CursorX) div groundW)*groundW,(CursorY div groundH)*groundH,groundW,groundH,ActiveElement-numTexGround,true,0,0,0)
      else
        Level0.GroundAdd(CameraMainX+CursorX,CursorY,groundW,groundH,ActiveElement-numTexGround,true,0,0,0);
    end;
    if (ActiveElement > numTexGround+numTexFonObj) and
       (ActiveElement <= numTexGround+numTexFonObj+numTexTrap) then
    begin
      if PixelElement.Status = 0 then
        Level0.TrapAdd(((CameraMainX+CursorX) div groundW)*groundW,(CursorY div groundH)*groundH,groundW,groundH,0,0,ActiveElement-numTexGround-numTexFonObj)
      else
        Level0.TrapAdd(CameraMainX+CursorX,CursorY,groundW,groundH,0,0,ActiveElement-numTexGround-numTexFonObj);
    end;
    if (ActiveElement > numTexGround+numTexFonObj+numtexTrap) and
       (ActiveElement <= numTexGround+numTexFonObj+numTexTrap+BonusRedoCount) then
    begin
      if PixelElement.Status = 0 then
        Level0.BonusAdd(((CameraMainX+CursorX) div groundW)*groundW+16,(CursorY div groundH)*groundH+32,BonusW,BonusH,0,ActiveElement-numTexGround-numTexFonObj-numTexTrap)
      else
        Level0.BonusAdd(CameraMainX+CursorX,CursorY,BonusW,BonusH,0,ActiveElement-numTexGround-numTexFonObj-numTexTrap);
    end;
    if (ActiveElement > numTexGround+numTexFonObj+numtexTrap+BonusRedoCount) and
       (ActiveElement <= numTexGround+numTexFonObj+numTexTrap+BonusRedoCount+PlaceRedoCount) then
    begin
      if PixelElement.Status = 0 then
        Level0.PlaceAdd(((CameraMainX+CursorX) div groundW)*groundW+16,(CursorY div groundH)*groundH+32,PlaceW,PlaceH,ActiveElement-numTexGround-numTexFonObj-numTexTrap-BonusRedoCount)
      else
        Level0.PlaceAdd(CameraMainX+CursorX,CursorY,PlaceW,PlaceH,ActiveElement-numTexGround-numTexFonObj-numTexTrap-BonusRedoCount);
    end;
    if (ActiveElement > numTexGround+numTexFonObj+numtexTrap+BonusRedoCount+PlaceRedoCount) and
       (ActiveElement <= numTexGround+numTexFonObj+numTexTrap+BonusRedoCount+PlaceRedoCount+EnemyRedoCount) then
    begin
      if PixelElement.Status = 0 then
        Level0.EnemyAdd(((CameraMainX+CursorX) div groundW)*groundW,(CursorY div groundH)*groundH,EnemyW,EnemyH,ActiveElement-numTexGround-numTexFonObj-numTexTrap-BonusRedoCount-PlaceRedoCount)
      else
        Level0.EnemyAdd(CameraMainX+CursorX,CursorY,EnemyW,EnemyH,ActiveElement-numTexGround-numTexFonObj-numTexTrap-BonusRedoCount-PlaceRedoCount);
    end;
  end;
  If inp.Down(Key_Right) then
    if CameraMainX+wnd.Width < level0.Width then
      CameraMainX:= CameraMainX+CameraRedoSpeed
    else
      CameraMainX:= Level0.Width-wnd.Width;
  if inp.Down(Key_Left) then
    if CameraMainX > 0 then
      CameraMainX:= CameraMainX-CameraRedoSpeed
    else
      CameraMainX:= 0;
  if inp.Down(Key_D) then
    Level0.AllDelete;
end;

procedure GridDraw;
var i: integer;
begin
  for i:= 1 to Level0.Width div 64 do
  begin
    if i*groundW-CameraMainX < wnd.Width-MenuWidth then
      DrawLine2D(i*groundW-CameraMainX,0,i*groundW-CameraMainX,wnd.Height,$000000);
  end;
  for i:= 1 to 9 do
  begin
    DrawLine2D(0,i*groundH,wnd.Width-MenuWidth,i*groundH,$000000);
  end;
end;

procedure RedactorDraw;
begin
  GridDraw;
  Level0.Draw;
  ElementDraw;
  ElementCursorDraw;
  PixelElement.Draw;
  AnimationElement.Draw;
  BtnSave.Draw;
  BtnLoad.Draw;
  EdtSpeed.Draw;
  EdtDeltaX.Draw;
  EdtDeltaY.Draw;
end;

procedure selectedElement(numElement: integer);
var tmpW, tmpH, x, y, tmpElement: integer;
begin
  tmpW:= groundW div 2;
  tmpH:= groundH div 2;
  x:= ElementX;
  y:= ElementY;
  tmpElement:= numElement;
  if (NumElement > 0) and (numElement <= numTexGround) then
  begin
    x:= ElementX;
    y:= ElementY;
    tmpElement:= numElement;
  end;
  if (numElement > numTexGround) and (numElement <= numTexGround+numTexFonObj) then
  begin
    x:= ElementX;
    y:= FonObjY;
    tmpElement:= numElement-numTexGround;
  end;
  if (numElement >  numTexGround+numTexFonObj) and
     (numElement <= numTexGround+numTexFonObj+numtexTrap) then
  begin
    x:= ElementX;
    y:= TrapY;
    tmpElement:= numElement-numTexGround-numTexTrap;
  end;
  if (numElement >  numTexGround+numTexFonObj+numTexTrap) and
     (numElement <= numTexGround+numTexFonObj+numTexTrap+BonusRedoCount) then
  begin
    x:= ElementX;
    y:= BonusRedoY;
    tmpElement:= numElement-numTexGround-numTexTrap-numTexFonObj;
  end;
  if (numElement >  numTexGround+numTexFonObj+numTexTrap+BonusRedoCount) and
     (numElement <= numTexGround+numTexFonObj+numTexTrap+BonusRedoCount+PlaceRedoCount) then
  begin
    x:= ElementX;
    y:= PlaceRedoY;
    tmpElement:= numElement-numTexGround-numTexTrap-numTexFonObj-BonusRedoCount;
  end;
  if (numElement >  numTexGround+numTexFonObj+numTexTrap+BonusRedoCount+PlaceRedoCount) and
     (numElement <= numTexGround+numTexFonObj+numTexTrap+BonusRedoCount+PlaceRedoCount+EnemyRedoCount) then
  begin
    x:= ElementX;
    y:= EnemyRedoY;
    tmpElement:= numElement-numTexGround-numTexTrap-numTexFonObj-BonusRedoCount-PlaceRedoCount;
  end;
  DrawLine2D((x-tmpW)+tmpW*tmpElement,y,(x-tmpW)+tmpW*tmpElement+tmpW,y,$0000FF);
  DrawLine2D((x-tmpW)+tmpW*tmpElement+tmpW,y,(x-tmpW)+tmpW*tmpElement+tmpW,y+tmpH,$0000FF);
  DrawLine2D((x-tmpW)+tmpW*tmpElement+tmpW,y+tmpH,(x-tmpW)+tmpW*tmpElement,y+tmpH,$0000FF);
  DrawLine2D((x-tmpW)+tmpW*tmpElement,y+tmpH,(x-tmpW)+tmpW*tmpElement,y,$0000FF);
end;

procedure ElementDraw;
begin
  glBegin(GL_QUADS);
    glColor4ub(50,50,50,255);
    glVertex2f(wnd.Width-MenuWidth,0);
    glVertex2f(wnd.Width,0);
    glColor4ub(150,150,150,255);
    glVertex2f(wnd.Width,wnd.Height);
    glVertex2f(wnd.Width-MenuWidth,wnd.Height);
  glEnd;
  MiniMapDraw;
  DrawSprite2D_simple(MainCursorTex,ElementX-32,ElementY,32,32);
  DrawSprite2D_simple(texAllGround,ElementX,ElementY,ElementW,ElementH);
  DrawSprite2D_simple(texFonObject,ElementX,FonObjY,FonObjW,FonObjH);
  DrawSprite2D(texTrap,ElementX,TrapY,TrapW,TrapH,0,255,$FFFFFF,false,TrapW,TrapH,TrapCount,TrapCount);
  DrawSprite2D_simple(texBonus,ElementX,BonusRedoY,BonusRedoW,BonusRedoH);
  DrawSprite2D_simple(texPlace,ElementX,PlaceRedoY,PlaceRedoW,PlaceRedoH);
  DrawSprite2D(texEnemy[1],ElementX,EnemyRedoY,EnemyW div 2,EnemyH div 2,0,255,$FFFFFF,false,EnemyW div 2,EnemyH div 2,1,EnemyCount);
  DrawSprite2D(texEnemy[2],ElementX+32,EnemyRedoY,EnemyW div 2,EnemyH div 2,0,255,$FFFFFF,false,EnemyW div 2,EnemyH div 2,1,EnemyCount);
  DrawSprite2D(texEnemy[3],ElementX+64,EnemyRedoY,EnemyW div 2,EnemyH div 2,0,255,$FFFFFF,false,EnemyW div 2,EnemyH div 2,1,EnemyCount);
  selectedElement(ActiveElement);
  DrawText2D(0,ElementX,16, ': '+IntToStr(ActiveElement),$FFFFFF);
  DrawText2D(0,16,48, 'CursorX: '+IntToStr(CursorX + CameraMainX),$FFFFFF);
  DrawText2D(0,16,64, 'CursorY: '+IntToStr(CursorY),$FFFFFF);
end;

procedure ElementCursorDraw;
begin
  if CursorX < wnd.Width-MenuWidth then
  begin
    if (ActiveElement > 0) and (ActiveElement <= numTexGround) then
    begin
      if PixelElement.Status = 0 then
        DrawSprite2D(texAllGround,((CameraMainX+CursorX) div groundW)*groundW-CameraMainX,(CursorY div groundH)*groundH,groundW,groundH,0,255,$FFFFFF,true,groundW,groundH,ActiveElement,numTexGround)
      else
        DrawSprite2D(texAllGround,CursorX,CursorY,groundW,groundH,0,255,$FFFFFF,true,groundW,groundH,ActiveElement,numTexGround);
    end;
    if (ActiveElement > numTexGround) and (ActiveElement <= numTexGround+numTexFonObj) then
    begin
      if PixelElement.Status = 0 then
        DrawSprite2D(texFonObject,((CameraMainX+CursorX) div groundW)*groundW-CameraMainX,(CursorY div groundH)*groundH,groundW,groundH,0,255,$FFFFFF,true,groundW,groundH,ActiveElement,numTexFonObj)
      else
        DrawSprite2D(texFonObject,CursorX,CursorY,groundW,groundH,0,255,$FFFFFF,true,groundW,groundH,ActiveElement,numTexFonObj);
    end;
    if (ActiveElement > numTexGround+numTexFonObj) and
       (ActiveElement <= numTexGround+numTexFonObj+numtexTrap) then
    begin
      if PixelElement.Status = 0 then
        DrawSprite2D(texTrap,((CameraMainX+CursorX) div groundW)*groundW-CameraMainX,(CursorY div groundH)*groundH,groundW,groundH,0,255,$FFFFFF,true,groundW,groundH,ActiveElement-AllFrameTrap,AllFrameTrap)
      else
        DrawSprite2D(texTrap,CursorX,CursorY,groundW,groundH,0,255,$FFFFFF,true,groundW,groundH,ActiveElement-AllFrameTrap,AllFrameTrap);
    end;
    if (ActiveElement > numTexGround+numTexFonObj+numTexTrap) and
       (ActiveElement <= numTexGround+numTexFonObj+numtexTrap+BonusRedoCount) then
    begin
      if PixelElement.Status = 0 then
        DrawSprite2D(texBonus,((CameraMainX+CursorX) div groundW)*groundW+16-CameraMainX,
        (CursorY div groundH)*groundH+32,BonusW,BonusH,0,255,$FFFFFF,true,BonusW,BonusH,ActiveElement-numTexGround-numTexFonObj-numTexTrap,BonusRedoCount)
      else
        DrawSprite2D(texBonus,CursorX,CursorY,BonusW,BonusH,0,255,$FFFFFF,true,BonusW,BonusH,ActiveElement-numTexGround-numTexFonObj-numTexTrap,BonusRedoCount);
    end;
    if (ActiveElement > numTexGround+numTexFonObj+numtexTrap+BonusRedoCount) and
       (ActiveElement <= numTexGround+numTexFonObj+numTexTrap+BonusRedoCount+PlaceRedoCount) then
    begin
      if PixelElement.Status = 0 then
        DrawSprite2D(texPlace,((CameraMainX+CursorX) div groundW)*groundW+16-CameraMainX,
        (CursorY div groundH)*groundH+32,PlaceW,PlaceH,0,255,
        $FFFFFF,true,PlaceW,PlaceH,ActiveElement-numTexGround-numTexFonObj-numTexTrap-BonusRedoCount,
        PlaceCount)
      else
        DrawSprite2D(texPlace,CursorX,CursorY,PlaceW,PlaceH,0,255,
        $FFFFFF,true,PlaceW,PlaceH,ActiveElement-numTexGround-numTexFonObj-numTexTrap-BonusRedoCount,
        PlaceCount);
    end;
    if (ActiveElement > numTexGround+numTexFonObj+numtexTrap+BonusRedoCount+PlaceRedoCount) and
       (ActiveElement <= numTexGround+numTexFonObj+numTexTrap+BonusRedoCount+PlaceRedoCount+EnemyRedoCount) then
    begin
      if PixelElement.Status = 0 then
        DrawSprite2D(texEnemy[ActiveElement-numTexGround-numTexFonObj-numTexTrap-BonusRedoCount-PlaceRedoCount],
        ((CameraMainX+CursorX) div groundW)*groundW-CameraMainX,(CursorY div groundH)*groundH,EnemyW,EnemyH,0,255,
        $FFFFFF,true,EnemyW,EnemyH,1,EnemyCount)
      else
        DrawSprite2D(texEnemy[ActiveElement-numTexGround-numTexFonObj-numTexTrap-BonusRedoCount-PlaceRedoCount],
        CursorX,CursorY,EnemyW,PlaceH,0,255,$FFFFFF,true,EnemyW,EnemyH,1,EnemyCount);
    end;
  end;
end;

procedure MiniMapDraw;
var numElement: integer;
procedure DrawQuad2D(x,y,w,h: integer; color: integer = $FFFFFF; alfa: integer = 255);
begin
  glColor4ub(GetRValue(Color),GetGValue(Color),GetBValue(Color),alfa);
  glBegin(GL_QUADS);
     glVertex2f(x,y);
     glVertex2f(x+w,y);
     glVertex2f(x+w,y+h);
     glVertex2f(x,y+h);
  glEnd;
end;
begin
  DrawQuad2D(633,386,Level0.Width div 32,(wnd.Height div 32)+4,$444444,255);
  for numElement:= 0 to Level0.countGround-1 do
    DrawQuad2D((level0.Ground[numElement].Rect.x div 32)+635,(level0.Ground[numElement].Rect.y div 32)+388,
               level0.Ground[numElement].Rect.w div 32,level0.Ground[numElement].Rect.h div 32,
               $CCCCCC,255);
  for numElement:= 0 to Level0.countTrap-1 do
    DrawQuad2D((level0.Trap[numElement].Rect.x div 32)+635,(level0.Trap[numElement].Rect.y div 32)+388,
               level0.Trap[numElement].Rect.w div 32,level0.Trap[numElement].Rect.h div 32,
               $FF0000,255);
  for numElement:= 0 to Level0.countBonus-1 do
    DrawQuad2D((level0.Bonus[numElement].Rect.x div 32)+635,(level0.Bonus[numElement].Rect.y div 32)+388,
               level0.Bonus[numElement].Rect.w div 32,level0.Bonus[numElement].Rect.h div 32,
               $00FF00,255);
  for numElement:= 0 to Level0.countPlace-1 do
    DrawQuad2D((level0.Place[numElement].Rect.x div 32)+635,(level0.Place[numElement].Rect.y div 32)+388,
               level0.Place[numElement].Rect.w div 32,level0.Place[numElement].Rect.h div 32,
               $FFFF00,255);
  for numElement:= 0 to Level0.countEnemy-1 do
    DrawQuad2D((level0.EnemyLevel[numElement].Rect.x div 32)+635,(level0.EnemyLevel[numElement].Rect.y div 32)+388,
               level0.EnemyLevel[numElement].Rect.w div 32,level0.EnemyLevel[numElement].Rect.h div 32,
               $0000CC,255);
end;

procedure SaveLevelRedo;
var F: File;
    numElement: integer;
begin
  Assign(F, 'level\level0.lvl');
  Rewrite(F,1);
  BlockWrite(F,Level0.Width, SizeOf(Level0.Width));
  BlockWrite(F,Level0.countGround, SizeOf(Level0.countGround));
  for numElement:= 0 to Level0.countGround-1 do
  begin
    BlockWrite(F,Level0.Ground[numElement].Rect, SizeOf(Level0.Ground[numElement].Rect));
    BlockWrite(F,Level0.Ground[numElement].numTex, SizeOf(Level0.Ground[numElement].numTex));
    BlockWrite(F,Level0.Ground[numElement].Active, SizeOf(Level0.Ground[numElement].Active));
    BlockWrite(F,Level0.Ground[numElement].Fon, SizeOf(Level0.Ground[numElement].Fon));
    BlockWrite(F,Level0.Ground[numElement].Speed, SizeOf(Level0.Ground[numElement].Speed));
    BlockWrite(F,Level0.Ground[numElement].StartX, SizeOf(Level0.Ground[numElement].StartX));
    BlockWrite(F,Level0.Ground[numElement].StartY, SizeOf(Level0.Ground[numElement].StartY));
    BlockWrite(F,Level0.Ground[numElement].DeltaXRigth, SizeOf(Level0.Ground[numElement].DeltaXRigth));
    BlockWrite(F,Level0.Ground[numElement].DeltaYUp, SizeOf(Level0.Ground[numElement].DeltaYUp));
    BlockWrite(F,Level0.Ground[numElement].Vector, SizeOf(Level0.Ground[numElement].Vector));
  end;
  BlockWrite(F,Level0.countTrap, SizeOf(Level0.countTrap));
  for numElement:= 0 to Level0.countTrap-1 do
  begin
    BlockWrite(F,Level0.Trap[numElement].Rect, SizeOf(Level0.Trap[numElement].Rect));
    BlockWrite(F,Level0.Trap[numElement].Id, SizeOf(Level0.Trap[numElement].Id));
    BlockWrite(F,Level0.Trap[numElement].Active, SizeOf(Level0.Trap[numElement].Active));
    BlockWrite(F,Level0.Trap[numElement].Angle, SizeOf(Level0.Trap[numElement].Angle));
    BlockWrite(F,Level0.Trap[numElement].SpeedX, SizeOf(Level0.Trap[numElement].SpeedX));
    BlockWrite(F,Level0.Trap[numElement].FrameNum, SizeOf(Level0.Trap[numElement].FrameNum));
  end;
  BlockWrite(F,Level0.countBonus, SizeOf(Level0.countBonus));
  for numElement:= 0 to Level0.countBonus-1 do
  begin
    BlockWrite(F,Level0.Bonus[numElement].Rect, SizeOf(Level0.Bonus[numElement].Rect));
    BlockWrite(F,Level0.Bonus[numElement].Id, SizeOf(Level0.Bonus[numElement].Id));
    BlockWrite(F,Level0.Bonus[numElement].Active, SizeOf(Level0.Bonus[numElement].Active));
    BlockWrite(F,Level0.Bonus[numElement].Angle, SizeOf(Level0.Bonus[numElement].Angle));
    BlockWrite(F,Level0.Bonus[numElement].Enable, SizeOf(Level0.Bonus[numElement].Enable));
  end;
  BlockWrite(F,Level0.countPlace, SizeOf(Level0.countPlace));
  for numElement:= 0 to Level0.countPlace-1 do
  begin
    BlockWrite(F,Level0.Place[numElement].Rect, SizeOf(Level0.Place[numElement].Rect));
    BlockWrite(F,Level0.Place[numElement].ID, SizeOf(Level0.Place[numElement].ID));
    BlockWrite(F,Level0.Place[numElement].Active, SizeOf(Level0.Place[numElement].Active));
    BlockWrite(F,Level0.Place[numElement].Check, SizeOf(Level0.Place[numElement].Check));
  end;
  BlockWrite(F,Level0.countEnemy, SizeOf(Level0.countEnemy));
  for numElement:= 0 to Level0.countEnemy-1 do
  begin
    BlockWrite(F,Level0.EnemyLevel[numElement].Rect, SizeOf(Level0.EnemyLevel[numElement].Rect));
    BlockWrite(F,Level0.EnemyLevel[numElement].Frame, SizeOf(Level0.EnemyLevel[numElement].Frame));
    BlockWrite(F,Level0.EnemyLevel[numElement].ID, SizeOf(Level0.EnemyLevel[numElement].ID));
    BlockWrite(F,Level0.EnemyLevel[numElement].Active, SizeOf(Level0.EnemyLevel[numElement].Active));
    BlockWrite(F,Level0.EnemyLevel[numElement].Health, SizeOf(Level0.EnemyLevel[numElement].Health));
    BlockWrite(F,Level0.EnemyLevel[numElement].Score, SizeOf(Level0.EnemyLevel[numElement].Score));
    BlockWrite(F,Level0.EnemyLevel[numElement].Speed, SizeOf(Level0.EnemyLevel[numElement].Speed));
    BlockWrite(F,Level0.EnemyLevel[numElement].Vector, SizeOf(Level0.EnemyLevel[numElement].Vector));
    BlockWrite(F,Level0.EnemyLevel[numElement].TimeReload, SizeOf(Level0.EnemyLevel[numElement].TimeReload));
    BlockWrite(F,Level0.EnemyLevel[numElement].RadiusAgr, SizeOf(Level0.EnemyLevel[numElement].RadiusAgr));
    BlockWrite(F,Level0.EnemyLevel[numElement].Life, SizeOf(Level0.EnemyLevel[numElement].Life));
    BlockWrite(F,Level0.EnemyLevel[numElement].Jump, SizeOf(Level0.EnemyLevel[numElement].Jump));
    BlockWrite(F,Level0.EnemyLevel[numElement].HeightJump, SizeOf(Level0.EnemyLevel[numElement].HeightJump));
  end;
  Close(F);
end;

procedure LoadLevelRedo;
var numElement: integer;
    F: file;
begin
  if not FileExists('level\level0.lvl') then
    exit;
  Assign(F, 'level\level0.lvl');
  Reset(F,1);
  SetLength(Level0.Ground,0);
  SetLength(Level0.Trap,0);
  SetLength(Level0.Bonus,0);
  SetLength(Level0.Place,0);
  SetLength(Level0.EnemyLevel,0);
  Level0.countGround:= 0;
  Level0.countTrap:= 0;
  Level0.countBonus:= 0;
  Level0.countPlace:= 0;
  Level0.countEnemy:= 0;
  BlockRead(F,Level0.Width, SizeOf(Level0.Width));
  BlockRead(F,Level0.countGround, SizeOf(Level0.countGround));
  SetLength(Level0.Ground,Level0.countGround);
  for numElement:= 0 to Level0.countGround-1 do
  begin
    level0.Ground[numElement]:= TGround.Create;
    BlockRead(F,Level0.Ground[numElement].Rect, SizeOf(Level0.Ground[numElement].Rect));
    BlockRead(F,Level0.Ground[numElement].numTex, SizeOf(Level0.Ground[numElement].numTex));
    BlockRead(F,Level0.Ground[numElement].Active, SizeOf(Level0.Ground[numElement].Active));
    BlockRead(F,Level0.Ground[numElement].Fon, SizeOf(Level0.Ground[numElement].Fon));
    BlockRead(F,Level0.Ground[numElement].Speed, SizeOf(Level0.Ground[numElement].Speed));
    BlockRead(F,Level0.Ground[numElement].StartX, SizeOf(Level0.Ground[numElement].StartX));
    BlockRead(F,Level0.Ground[numElement].StartY, SizeOf(Level0.Ground[numElement].StartY));
    BlockRead(F,Level0.Ground[numElement].DeltaXRigth, SizeOf(Level0.Ground[numElement].DeltaXRigth));
    BlockRead(F,Level0.Ground[numElement].DeltaYUp, SizeOf(Level0.Ground[numElement].DeltaYUp));
    BlockRead(F,Level0.Ground[numElement].Vector, SizeOf(Level0.Ground[numElement].Vector));
  end;
  BlockRead(F,Level0.countTrap, SizeOf(Level0.countTrap));
  SetLength(Level0.Trap,Level0.countTrap);
  for numElement:= 0 to Level0.countTrap-1 do
  begin
    Level0.Trap[numElement]:= TTrap.Create;
    BlockRead(F,Level0.Trap[numElement].Rect, SizeOf(Level0.Trap[numElement].Rect));
    BlockRead(F,Level0.Trap[numElement].Id, SizeOf(Level0.Trap[numElement].Id));
    BlockRead(F,Level0.Trap[numElement].Active, SizeOf(Level0.Trap[numElement].Active));
    BlockRead(F,Level0.Trap[numElement].Angle, SizeOf(Level0.Trap[numElement].Angle));
    BlockRead(F,Level0.Trap[numElement].SpeedX, SizeOf(Level0.Trap[numElement].SpeedX));
    BlockRead(F,Level0.Trap[numElement].FrameNum, SizeOf(Level0.Trap[numElement].FrameNum));
  end;
  BlockRead(F,Level0.countBonus, SizeOf(Level0.countBonus));
  SetLength(Level0.Bonus,Level0.countBonus);
  for numElement:= 0 to Level0.countBonus-1 do
  begin
    Level0.Bonus[numElement]:= TBonus.Create;
    BlockRead(F,Level0.Bonus[numElement].Rect, SizeOf(Level0.Bonus[numElement].Rect));
    BlockRead(F,Level0.Bonus[numElement].Id, SizeOf(Level0.Bonus[numElement].Id));
    BlockRead(F,Level0.Bonus[numElement].Active, SizeOf(Level0.Bonus[numElement].Active));
    BlockRead(F,Level0.Bonus[numElement].Angle, SizeOf(Level0.Bonus[numElement].Angle));
    BlockRead(F,Level0.Bonus[numElement].Enable, SizeOf(Level0.Bonus[numElement].Enable));
  end;
  BlockRead(F,Level0.countPlace, SizeOf(Level0.countPlace));
  SetLength(Level0.Place,Level0.countPlace);
  for numElement:= 0 to Level0.countPlace-1 do
  begin
    Level0.Place[numElement]:= TPlace.Create;
    Level0.Place[numElement].Init(0,0,0,0,0);
    BlockRead(F,Level0.Place[numElement].Rect, SizeOf(Level0.Place[numElement].Rect));
    BlockRead(F,Level0.Place[numElement].ID, SizeOf(Level0.Place[numElement].ID));
    BlockRead(F,Level0.Place[numElement].Active, SizeOf(Level0.Place[numElement].Active));
    BlockRead(F,Level0.Place[numElement].Check, SizeOf(Level0.Place[numElement].Check));
  end;
  BlockRead(F,Level0.countEnemy, SizeOf(Level0.countEnemy));
  SetLength(Level0.EnemyLevel,Level0.countEnemy);
  for numElement:= 0 to Level0.countEnemy-1 do
  begin
    Level0.EnemyLevel[numElement]:= TEnemy.Create;
    Level0.EnemyLevel[numElement].Init(0,0,0,0,0);
    BlockRead(F,Level0.EnemyLevel[numElement].Rect, SizeOf(Level0.EnemyLevel[numElement].Rect));
    BlockRead(F,Level0.EnemyLevel[numElement].Frame, SizeOf(Level0.EnemyLevel[numElement].Frame));
    BlockRead(F,Level0.EnemyLevel[numElement].ID, SizeOf(Level0.EnemyLevel[numElement].ID));
    BlockRead(F,Level0.EnemyLevel[numElement].Active, SizeOf(Level0.EnemyLevel[numElement].Active));
    BlockRead(F,Level0.EnemyLevel[numElement].Health, SizeOf(Level0.EnemyLevel[numElement].Health));
    BlockRead(F,Level0.EnemyLevel[numElement].Score, SizeOf(Level0.EnemyLevel[numElement].Score));
    BlockRead(F,Level0.EnemyLevel[numElement].Speed, SizeOf(Level0.EnemyLevel[numElement].Speed));
    BlockRead(F,Level0.EnemyLevel[numElement].Vector, SizeOf(Level0.EnemyLevel[numElement].Vector));
    BlockRead(F,Level0.EnemyLevel[numElement].TimeReload, SizeOf(Level0.EnemyLevel[numElement].TimeReload));
    BlockRead(F,Level0.EnemyLevel[numElement].RadiusAgr, SizeOf(Level0.EnemyLevel[numElement].RadiusAgr));
    BlockRead(F,Level0.EnemyLevel[numElement].Life, SizeOf(Level0.EnemyLevel[numElement].Life));
    BlockRead(F,Level0.EnemyLevel[numElement].Jump, SizeOf(Level0.EnemyLevel[numElement].Jump));
    BlockRead(F,Level0.EnemyLevel[numElement].HeightJump, SizeOf(Level0.EnemyLevel[numElement].HeightJump));
  end;
  Close(F);
end;

procedure AnimationProc;
var num: integer;
begin
  if AnimationElement.Status = 0 then
    AnimationOn:= true
  else
  begin
    AnimationOn:= false;
    for num:= 0 to Level0.countGround-1 do
    begin
      Level0.Ground[num].Rect.x:= Level0.Ground[num].StartX;
      Level0.Ground[num].Rect.y:= Level0.Ground[num].StartY;
    end;
    for num:= 0 to Level0.countTrap-1 do
    begin
      if Level0.Trap[num].FrameNum = 4 then
        Level0.Trap[num].FrameNum:= 4
      else
        Level0.Trap[num].FrameNum:= 1;
      Level0.Trap[num].Angle:= 0;
    end;
  end;
end;

end.
