program Reindeer;

uses
  Windows,
  Math,
  OpenGL,
  sNail,
  uLevel,
  uUtils,
  uSpace,
  uVect,
  uBody,
  uShape,
  uPolyShape,
  uJoint,
  uGame,
  uPlayer,
  uGL,
  uBB,
  uCollision,
  uArbiter,
  uParticles,
  uGui,
  uMenu;

//{$R *.res}

procedure PreloadEng;
begin
  glHint(GL_POLYGON_SMOOTH_HINT, GL_NICEST);
  glEnable(GL_POLYGON_SMOOTH);
  glEnable(GL_LINE_SMOOTH);
  glEnable(GL_POINT_SMOOTH);
  glPointSize(cfg.PointSize);
  glLineWidth(cfg.LineWidth);

  fntMain.Load('data\fnt.nfa', -2);
  fntMain.SetTexture(tex_Load(nil, 'data\textures\fnt.png', true));

  gl_SetBlend(BLEND_SUB);
  gl_ClearScreen(true);
  gl_SetOrtho;
  glColor3f(1, 1, 1);
  fntMain.Render(10, 10, '...');
end;

procedure InitEng;
begin
  snd_Init;
  LoadTexFromList(TEXTURES_PATH + 'grounds.lst', @LoadTexGrounds);
  LoadTexFromList(TEXTURES_PATH + 'decors.lst', @LoadTexDecors);

  fntNum.Load('data\fntNum.nfa');
  fntNum.SetTexture(tex_Load(nil, 'data\textures\fntNum.png', true));

  texCursor := tex_Load(nil, TEXTURES_PATH + 'cursor.png', false);
  texGui := tex_Load(nil, TEXTURES_PATH + 'gui.png', true);
  texBGround := tex_Load(nil, TEXTURES_PATH + 'sky.jpg',true);
  texCar := tex_Load(nil, TEXTURES_PATH + 'car.png', false);
  texRetort := tex_Load(nil, TEXTURES_PATH + 'retort.png', false);
  texSpark := tex_Load(nil, TEXTURES_PATH + 'star.tga', true);
  texSnow := tex_Load(nil, TEXTURES_PATH + 'snow.bmp', true);
  texBonuses := tex_Load(nil, TEXTURES_PATH + 'bonuses.png', false);
  texBonus := tex_Load(nil, TEXTURES_PATH + 'bonus.png', false);
  texLog := tex_Load(nil, TEXTURES_PATH + 'log.png', false);
  texLog2 := tex_Load(nil, TEXTURES_PATH + 'log2.png', false);
  texIce := tex_Load(nil, TEXTURES_PATH + 'ice.png', false);
  texHud := tex_Load(nil, TEXTURES_PATH + 'hud.png', false);

  sndRetort := snd_Load(nil, SOUNDS_PATH + 'retort.wav');
  sndMotor := snd_Load(nil, SOUNDS_PATH + 'diesel02.wav');

  sndFinish := snd_Load(nil, SOUNDS_PATH + 'finish.wav');
  sndJump := snd_Load(nil, SOUNDS_PATH + 'jump.wav');
  sndCrash := snd_Load(nil, SOUNDS_PATH + 'crash.wav');
  sndClick := snd_Load(nil, SOUNDS_PATH + 'click.wav');
  sndBonus := snd_Load(nil, SOUNDS_PATH + 'bonus.wav');
  sndEat := snd_Load(nil, SOUNDS_PATH + 'eat.wav');
  sndDrink := snd_Load(nil, SOUNDS_PATH + 'drink.wav');

  game.Init;
  CreateFrames;
  gui.Activate('MainMenu');

  if cfg.Music then stream_Play(MUSIC_PATH + 'music1.mp3', true);
  snd_SetVolumeAll(cfg.Volume);
end;

procedure UpdateEng;
begin
  gui.Update;
  game.Update;
  inp_Reset;
end;

procedure RenderEng;
begin
  gl_ClearScreen(true);
  gl_SetOrtho;
  game.Render;
  gui.Render;
  //fntMain.Render(20,20,'FPS: '+Int2Str(gl_GetFPS));
end;

procedure UnloadEng;
begin
  game.Free;
end;

begin
  Randomize;
  ShowCursor(false);
  tex_Params(ini_ReadInt(CONFIG_INI, 'graphics', 'texture_filter'));

  snail_SetName('Reindeer');
  snail_RegProc(PROC_PRELOAD, @PreloadEng);
  snail_RegProc(PROC_INIT,  @InitEng);
  snail_RegProc(PROC_UPDATE, @UpdateEng);
  snail_RegProc(PROC_RENDER, @RenderEng);
  snail_RegProc(PROC_FREE, @UnloadEng);
  snail_SetTimer(11);

  cfg := ReadConfig;
  with cfg do
    snail_Run(ResX, ResY, 32, 0, 0, FullScreen, true, true);
end.
