unit objects;
{$Warnings off}
{$Hints on}

interface
uses windows,OpenGL,engine,l_math;

var
  d                  : DEVMODE;
  WndClass           : TWndClass;
  msg                : TMsg;
  h_Wnd              : HWND;
  h_dc               : hdc;


  Width              : Integer = 590;
  Height             : Integer = 790;
  BPP                : Integer = 32;
  FULLSCREEN         : Boolean = false;
  Done               : boolean;

  APPDIR,
  SFXDIR,
  MapsDIR,
  ModelsDir,
  TextureDIR         : String;

  keys               : array [0..255] of boolean;
  fpstime,
  fps,fpscount,fov       : integer;
  FrameTime,LastTime : integer;
  mpos               : tpoint;
  MouseSpeed         : single =10;
  Loaded             : boolean;

  Map                : IModels;

  OldWaterTime       : Integer;
  Water              : IWater;
  DrawGL             : IDrawGL;
  GLFX               : IGLFX;
//
  EnemysModels       : IModels;
  EnemysGLFX         : IGLFX;
//
  WeaponModels       : IModels;
  Coll               : ICollide;
  DSound             : IDXSound;
  fon,numbers,pause_b,new_l,logo,help_b,cell,tadam,
  downfon,bad,good,pausa,secret,lvlup,
  f_1,f_2,f_3,f_4,f_5,f_6,f_7,f_8,f_9,f_10,f_11,f_12          : Cardinal;


function GetTargetPos(Heading,Tilt:Single):TVector;
function GetOffsetToTarget(POS,TGPOS:TVector):TVector;
Procedure SetProjection(W, H: integer; Ortho: boolean);
function IntToStr(Num : Integer) : String;



function isCollision (Var POS:TVector;R:Single):boolean;
function isLineCollision (Var BP,EP:TVector):TVector;
Procedure UpdateFrameTime;
function booltostr(b:boolean):string;

procedure drawnum(x,y,size : Single ; str:string; assignrigth:boolean;Texture:Cardinal);

implementation
uses math;
function booltostr(b:boolean):string;
begin
if b then result:='1' else result:='0';
end;



function isCollision (Var POS:TVector;R:Single):boolean;
begin
 result:=map.Model4Collision(0,vector(0,0,0),Pos,r);
end;

function isLineCollision (Var BP,EP:TVector):Tvector;
begin
 result:=map.LineCollision2(0,vector(0,0,0),bp,ep);
end;

Procedure UpdateFrameTime;
begin
FrameTime   := GetTickCount - LastTime;         //    
LastTime    := GetTickCount;                    //      
end;

function IntToStr(Num : Integer) : String;
begin
  Str(Num, result);
end;

function CalcFov(fov, width, height: Single): Single;
var
  a, x: Single;
const
  M_PI = 3.14159265358979323846;
begin
  if (fov < 1) or (fov > 179) then fov:=45;
  x := width / tan(fov / 360 * M_PI);
  a := arctan(height / x);
  a := a * 360 / M_PI;
  result := a;
end;

Procedure SetProjection(W, H: integer; Ortho: boolean);
begin
  if (GetAsyncKeyState(vk_Rbutton) <> 0) then fov:=45 else fov:=85;
  glMatrixMode(GL_PROJECTION);            //   
  glLoadIdentity();                       //  
  if ortho then
    glOrtho(0, w, h, 0, -1, 100)          //  2
  else
    gluPerspective(CalcFov(fov,w,h), W/H, 2,100000);  //  3

  glMatrixMode(GL_MODELVIEW);             //   
  glLoadIdentity();                       //  

end;

function GetTargetPos(Heading,Tilt:Single):TVector;
var
HD,TL  :Single;
begin
HD     := (Heading-90)*(pi/180);
TL     :=  Tilt*(pi/180);
Result := vector(cos(hd) * cos(tl),
                 sin(-tl),
                 sin(hd) * cos(tl));

end;

function GetOffsetToTarget(POS,TGPOS:TVector):TVector;
begin
Result:= V_div(V_sub(tgpos,pos),
               V_DIST(POS,TGPOS));
end;


procedure drawnum(x,y,size : Single ; str:string; assignrigth:boolean;Texture:Cardinal);
var i:byte;
    ch:char;
    az,kord:Single;
begin
  GlEnable(GL_BLEND);
  GlBlendFunc(GL_SRC_ALPHA	, GL_ONE);
  GlBindTexture(GL_TEXTURE_2D, Texture);
  glpushmatrix;
  if assignrigth then
  X := X - length(str)*size;
  glTranslate(x-size, y, 1);

  for i:=1 to length(str) do
  begin
     ch:=str[i];
      if ch in ['1','2','3','4','5','6','7','8','9','0'] then
    begin
    kord:=0.1;//32/320;
    az:=kord*(ord(ch)+2);

    glBegin(gl_polygon);
      glTexCoord2f(az,0);       glVertex3f((i*size),0,0);
      glTexCoord2f(az+kord,0);  glVertex3f(((i+1)*size),0, 0);
      glTexCoord2f(az+kord,1);  glVertex3f(((i+1)*size),size, 0);
      glTexCoord2f(az,1);       glVertex3f((i*size),size, 0);
    glEnd;
    end;
  end;
 glDisable(GL_BLEND);
 glpopmatrix;



end;

end.